#include "537thread.h"
#include <stdio.h>

lock_t lock;

void func1();
void func2();

int main(int argc, char *argv[])
{	thread_libinit();
	thread_lock_init(&lock);

	thread_create(func1, NULL);
	thread_create(func2, NULL);

	int rc = thread_waitall();
	printf("returned: %d\n", rc); fflush(stdout);
	exit(0);
}

void func1()
{	int i;
	for(i = 0; i < 3; i++)
	{	thread_lock(&lock);
		printf("func1: %d\n", i);
		thread_yield();
		printf("func1: %d\n", i);
		thread_unlock(&lock);
		thread_yield();
	}
}

void func2()
{	int i;
	for(i = 0; i < 3; i++)
	{	thread_lock(&lock);
		printf("FUNC2: %d\n", i);
		thread_unlock(&lock);
		thread_yield();
	}
}
