#include "537thread.h"
#include <stdio.h>

lock_t lock;

void func1();
void func(void *i);
void func4();

int main(int argc, char *argv[])
{	thread_libinit();
	thread_lock_init(&lock);

	thread_create(func1, NULL);
	thread_create(func, (void *)2);
	thread_create(func, (void *)3);
	thread_create(func4, NULL);

	int rc = thread_waitall();
	printf("returned: %d\n", rc); fflush(stdout);
	exit(0);
}

void func1()
{	thread_lock(&lock);
	printf("func1: lock taken\n");
	thread_yield();
	thread_unlock(&lock);
	printf("func1: lock released\n");
}

void func(void *i)
{	thread_lock(&lock);
	printf("func%d: run\n", (int)i);
	thread_unlock(&lock);
}

void func4()
{	printf("func4: run\n");
	thread_yield();
	thread_lock(&lock);
	printf("func4: lock taken\n");
	thread_yield();
	thread_unlock(&lock);
	printf("func4: lock released\n");
}
