#include <stdio.h>
#include "537thread.h"

void *threadLoop(void *id)
{
  int threadId = (int)id;
  int i;
  for(i=0;i<10;i++){
    printf("Thread Id:%d Counter:%d\n", threadId, i);
    if(i==4) thread_yield();
  }
  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  int i;
  thread_libinit();
  for(i=0;i<nThreads;i++){
    thread_create(threadLoop,(void *)i);
  }
  thread_waitall();
  return 0;
}
