#include <stdio.h>
#include "537thread.h"

int nIncrements = 0;
int globalCounter = 0;
lock_t guardGlobal;

void *threadIncrements(void *id)
{
  int threadId = (int)id;
  int i;
  for(i=0;i<nIncrements;i++){
    thread_lock(&guardGlobal);
    globalCounter++;
    thread_unlock(&guardGlobal);
  }
  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  nIncrements = atoi(argv[2]);
  int i;
  thread_libinit();
  thread_lock_init(&guardGlobal);

  for(i=0;i<nThreads;i++){
    thread_create(threadIncrements,(void *)i);
  }
  thread_waitall();

  printf("Number of increments must be %d and it is %d\n", nThreads*nIncrements, globalCounter);
  return 0;
}
