#include <stdio.h>
#include "537thread.h"

lock_t lockCond;
int globalCount;

void *threadOne(void *in)
{
  int id = (int) in;
  int i;
  thread_lock(&lockCond);
  for(i = 0; i < 10; i++){    
    globalCount++;

    printf("From thread %d global count = %d\n", id, globalCount);

    if(i == 4){
      thread_yield();
    }
  }
  thread_unlock(&lockCond);

  return NULL;
}

void *threadTwo(void *in)
{
  int id = (int) in;
  int i;
  thread_lock(&lockCond);

  for(i = 0; i < 10; i++){    
    globalCount++;

    printf("From thread %d global count = %d\n", id, globalCount);

  }
  thread_unlock(&lockCond);


  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  nIncrements = atoi(argv[2]);
  int i;
  globalCount = 0;
  thread_libinit();
  thread_lock_init(&lockCond);


  thread_create(threadOne,(void *)0);
  for(i = 1; i < 5; i++){
    thread_create(threadTwo,(void *)i);
  }

  thread_waitall();

  return 0;
}
