#include <stdio.h>
#include "537thread.h"

lock_t lockCond;
cond_t condWait;

void *threadOne(void *in)
{
  
  thread_lock(&lockCond);
  thread_wait(&condWait);
  printf("My id = %d\n", (int)in);
  thread_unlock(&lockCond);

  return NULL;
}

void *threadTwo(void *in)
{
  int i;
  for(i = 0;i<5;i++){
    thread_lock(&lockCond);
    thread_signal(&condWait);
    thread_unlock(&lockCond);
    thread_yield();
  }
  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  nIncrements = atoi(argv[2]);
  int i;
  thread_libinit();
  thread_lock_init(&lockCond);
  thread_cond_init(&condWait);

  for(i = 0;i<5;i++){
    thread_create(threadOne,(void *)i);
  }
  thread_create(threadTwo,(void *)i);
  thread_waitall();

  return 0;
}
