#include <stdlib.h>
#include <stdio.h>
#include "537thread.h"


void thread1(void)
{
	thread_yield();
	printf("thread1 complete\n");
}

void thread2(void)
{
	printf("thread2 complete\n");
}

void thread3(void)
{
	printf("thread3 complete\n");
}

void thread4(void)
{
	printf("thread4 complete\n");
}

int main(int argc, char * args[])
{
	thread_libinit();

	thread_create((void *)thread1, 0);
	thread_create((void *)thread2, 0);
	thread_create((void *)thread3, 0);
	thread_create((void *)thread4, 0);

	if (thread_waitall() < 0)
		printf("Deadlock occurred\n");
	else
		printf("All threads exited\n");

	return 0;
}
