#include <stdlib.h>
#include <stdio.h>
#include "537thread.h"


void thread1(void * arg)
{
	char * str = arg;
	thread_yield();
	printf(str);
}

void thread2(void * arg)
{
	char * str = arg;
	printf(str);
}

int main(int argc, char * args[])
{
	thread_libinit();

	thread_create((void *)thread1, "thread 1 complete\n");
	thread_create((void *)thread2, "thread 2 complete\n");
	thread_create((void *)thread1, "thread 3 complete\n");
	thread_create((void *)thread2, "thread 4 complete\n");

	if (thread_waitall() < 0)
		printf("Deadlock occurred\n");
	else
		printf("All threads exited\n");

	return 0;
}
