#include "537thread.h"

void threadOne(void* integer){
	int i = ((int) integer);
	
	int x;
	for (x = 0; x < i; x++){
		printf("%d",x);
	}
	printf("\n");
	fflush(stdout);
}

void threadTwo (void* integer){
	printf("THREAD 2!\n");
	fflush(stdout);
}

void threadThree(void* integer){
	int i = ((int) integer);
	
	//if(!(i%10)){ printf("%d\n",i); }
}

int main(int argc, char* argv[]) {
	printf("library init\n");
	thread_libinit();
	printf("library init complete\n");
	
	printf("thread create\n");
	int i = 10;
	thread_create(threadOne, (void*) i);
	printf("thread create complete\n");

	printf("thread create\n");
	i = 20;
	thread_create(threadOne, (void*) i);
	printf("thread create complete\n");

	printf("thread create\n");
	i = 30;
	thread_create(threadOne, (void*) i);
	printf("thread create complete\n");

	printf("thread create\n");
	i = 40;
	thread_create(threadTwo, (void*) i);
	printf("thread create complete\n");
	
	int returnVal;
	for (i = 1; i < 1000001; i++){
		thread_create(threadThree, (void*) i);
	//	returnVal = thread_waitall();
	//	printf("thread_waitall returns %d\n", returnVal);
		if(!(i%10000)) { printf("%d\n", i); }
		fflush(stdout);
		thread_yield();
	}

	printf("~~~~~~~~~~~~~thread_waitall called~~~~~~~~~~~~~\n");
	i = thread_waitall();
	printf("\nthread_waitall returns %d\n\n", i);
	
	return 0;
}
