#include <stdio.h>
#include <stdlib.h>
#include <ucontext.h>
#include <assert.h>
#include "537thread.h"

lock_t lock;

void
func(void * x){
	thread_lock(&lock);
	int y = (int)x;
	printf("Test\n");
	thread_yield();
	printf("ctr = %d\n", y);
	thread_unlock(&lock);
}

int 
main(int argc, char *argv[]){
	thread_libinit();
	thread_lock_init(&lock);
	printf("Start testing\n");
	thread_create(func, (void *)300);
	thread_create(func, (void *)400);
	thread_create(func, (void *)500);
	thread_waitall();
	printf("End testing\n");
	return 0;
}
