#include "537thread.h"
#include <stdio.h>

int j=0;

cond_t condone;
lock_t lockone;

void func1(void *initint){
	thread_lock(&lockone);
	printf("inside func1, after lock, before yield, num:%d\n",(int)initint);
	thread_yield();
	printf("inside func1, after yield, before unlock, num:%d\n",(int)initint);
	thread_unlock(&lockone);
	printf("inside func1, after unlock, num:%d\n",(int)initint);
}

void func2(void *initint){
	thread_lock(&lockone);
	printf("%d:inside func2, b4 yield\n",(int)initint);
	thread_yield();
	printf("%d:inside func2, after yield\n",(int)initint);
	thread_unlock(&lockone);
}

int main(int argc, char *argv[]){
	thread_libinit();

	thread_lock_init(&lockone);
	thread_cond_init(&condone);
	
	for(j=0; j<3; j++){ thread_create(func1,(void*)j); }

	//printf("before yield in main\n");
	//thread_yield();
	printf("before create in main\n");
	thread_create(func2,(void*)55);
	thread_create(func1,(void*)1);
	printf("before waitall in main\n");
	thread_waitall();

	return 0;
}     
