#include <stdio.h>
#include "537thread.h"

lock_t lockCond;
cond_t signalFromOne, signalFromTwo;

void *threadOne(void *in)
{
  int i;
  for(i=0;i<5;i++){
    thread_lock(&lockCond);
    thread_wait(&lockCond, &signalFromTwo);
    printf("1");
    thread_signal(&signalFromOne);
    thread_unlock(&lockCond);
  }
  return NULL;
}

void *threadTwo(void *in)
{
  int i;
  for(i=0;i<5;i++){
    thread_lock(&lockCond);
    thread_signal(&signalFromTwo);
    thread_wait(&lockCond, &signalFromOne);
    printf("2");
    thread_unlock(&lockCond);
  }
  return NULL;
}

int main(int argc, char **argv)
{
  thread_libinit();
  thread_lock_init(&lockCond);
  thread_cond_init(&signalFromOne);
  thread_cond_init(&signalFromTwo);


  thread_create(threadOne,NULL);
  thread_create(threadTwo,NULL);
  thread_waitall();

  return 0;
}
