#include <stdio.h>
#include "537thread.h"

lock_t lockCond;
cond_t condWait;

void *threadOne(void *in)
{
  thread_lock(&lockCond);
  thread_wait(&lockCond, &condWait);
  printf("2");
  thread_signal(&condWait);
  printf("3");
  thread_unlock(&lockCond);

  return NULL;
}

void *threadTwo(void *in)
{
  thread_lock(&lockCond);
  thread_signal(&condWait);
  printf("1");
  thread_wait(&lockCond, &condWait);
  printf("4\n");
  thread_unlock(&lockCond);

  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  nIncrements = atoi(argv[2]);
  int i;
  thread_libinit();
  thread_lock_init(&lockCond);
  thread_cond_init(&condWait);


  thread_create(threadOne,NULL);
  thread_create(threadTwo,NULL);
  thread_waitall();

  return 0;
}
