#include <stdio.h>
#include "537thread.h"

lock_t A,B;

void *threadLockAB(void *id)
{
  printf("Thread id = %d,Before acquiring A\n", (int)id);
  thread_lock(&A);
  printf("Thread id = %d,After acquiring A\n", (int)id);
  thread_yield();
  printf("Thread id = %d,Before acquiring B\n", (int)id);
  thread_lock(&B);
  printf("Thread id = %d,After acquiring B\n", (int)id);

  thread_unlock(&B);
  thread_unlock(&A);
  return NULL;
}
void *threadLockBA(void *id)
{
  printf("Thread id = %d,Before acquiring B\n", (int)id);
  thread_lock(&B);
  printf("Thread id = %d,After acquiring B\n", (int)id);
  thread_yield();
  printf("Thread id = %d,Before acquiring A\n", (int)id);
  thread_lock(&A);
  printf("Thread id = %d,After acquiring A\n", (int)id);

  thread_unlock(&A);
  thread_unlock(&B);
  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  nIncrements = atoi(argv[2]);
  int i;
  thread_libinit();
  thread_lock_init(&A);
  thread_lock_init(&B);

  thread_create(threadLockAB,(void *)0);
  thread_create(threadLockBA,(void *)1);

  int ret =  thread_waitall();
  printf("Deadlock detected . Return value = %d\n", ret);

  return 0;
}
